! Copyright (C) 2005, 2006 Doug Coleman.
! See http://factorcode.org/license.txt for BSD license.
USING: alien alien.c-types alien.syntax alien.destructors
kernel windows.types math.bitwise literals ;
IN: windows.gdi32

CONSTANT: BI_RGB 0
CONSTANT: BI_RLE8 1
CONSTANT: BI_RLE4 2
CONSTANT: BI_BITFIELDS 3
CONSTANT: BI_JPEG 4
CONSTANT: BI_PNG 5
CONSTANT: LF_FACESIZE 32
CONSTANT: LF_FULLFACESIZE 64
CONSTANT: CA_NEGATIVE 1
CONSTANT: CA_LOG_FILTER 2
CONSTANT: ILLUMINANT_DEVICE_DEFAULT 0
CONSTANT: ILLUMINANT_A 1
CONSTANT: ILLUMINANT_B 2
CONSTANT: ILLUMINANT_C 3
CONSTANT: ILLUMINANT_D50 4
CONSTANT: ILLUMINANT_D55 5
CONSTANT: ILLUMINANT_D65 6
CONSTANT: ILLUMINANT_D75 7
CONSTANT: ILLUMINANT_F2 8
ALIAS: ILLUMINANT_MAX_INDEX ILLUMINANT_F2
ALIAS: ILLUMINANT_TUNGSTEN ILLUMINANT_A
ALIAS: ILLUMINANT_DAYLIGHT ILLUMINANT_C
ALIAS: ILLUMINANT_FLUORESCENT ILLUMINANT_F2
ALIAS: ILLUMINANT_NTSC ILLUMINANT_C
CONSTANT: RGB_GAMMA_MIN 2500
CONSTANT: RGB_GAMMA_MAX 65000
CONSTANT: REFERENCE_WHITE_MIN 6000
CONSTANT: REFERENCE_WHITE_MAX 10000
CONSTANT: REFERENCE_BLACK_MIN 0
CONSTANT: REFERENCE_BLACK_MAX 4000
CONSTANT: COLOR_ADJ_MIN -100
CONSTANT: COLOR_ADJ_MAX 100
CONSTANT: CCHDEVICENAME 32
CONSTANT: CCHFORMNAME 32
CONSTANT: DI_COMPAT 4
CONSTANT: DI_DEFAULTSIZE 8
CONSTANT: DI_IMAGE 2
CONSTANT: DI_MASK 1
CONSTANT: DI_NORMAL 3
CONSTANT: DI_APPBANDING 1
CONSTANT: EMR_HEADER 1
CONSTANT: EMR_POLYBEZIER 2
CONSTANT: EMR_POLYGON 3
CONSTANT: EMR_POLYLINE 4
CONSTANT: EMR_POLYBEZIERTO 5
CONSTANT: EMR_POLYLINETO 6
CONSTANT: EMR_POLYPOLYLINE 7
CONSTANT: EMR_POLYPOLYGON 8
CONSTANT: EMR_SETWINDOWEXTEX 9
CONSTANT: EMR_SETWINDOWORGEX 10
CONSTANT: EMR_SETVIEWPORTEXTEX 11
CONSTANT: EMR_SETVIEWPORTORGEX 12
CONSTANT: EMR_SETBRUSHORGEX 13
CONSTANT: EMR_EOF 14
CONSTANT: EMR_SETPIXELV 15
CONSTANT: EMR_SETMAPPERFLAGS 16
CONSTANT: EMR_SETMAPMODE 17
CONSTANT: EMR_SETBKMODE 18
CONSTANT: EMR_SETPOLYFILLMODE 19
CONSTANT: EMR_SETROP2 20
CONSTANT: EMR_SETSTRETCHBLTMODE 21
CONSTANT: EMR_SETTEXTALIGN 22
CONSTANT: EMR_SETCOLORADJUSTMENT 23
CONSTANT: EMR_SETTEXTCOLOR 24
CONSTANT: EMR_SETBKCOLOR 25
CONSTANT: EMR_OFFSETCLIPRGN 26
CONSTANT: EMR_MOVETOEX 27
CONSTANT: EMR_SETMETARGN 28
CONSTANT: EMR_EXCLUDECLIPRECT 29
CONSTANT: EMR_INTERSECTCLIPRECT 30
CONSTANT: EMR_SCALEVIEWPORTEXTEX 31
CONSTANT: EMR_SCALEWINDOWEXTEX 32
CONSTANT: EMR_SAVEDC 33
CONSTANT: EMR_RESTOREDC 34
CONSTANT: EMR_SETWORLDTRANSFORM 35
CONSTANT: EMR_MODIFYWORLDTRANSFORM 36
CONSTANT: EMR_SELECTOBJECT 37
CONSTANT: EMR_CREATEPEN 38
CONSTANT: EMR_CREATEBRUSHINDIRECT 39
CONSTANT: EMR_DELETEOBJECT 40
CONSTANT: EMR_ANGLEARC 41
CONSTANT: EMR_ELLIPSE 42
CONSTANT: EMR_RECTANGLE 43
CONSTANT: EMR_ROUNDRECT 44
CONSTANT: EMR_ARC 45
CONSTANT: EMR_CHORD 46
CONSTANT: EMR_PIE 47
CONSTANT: EMR_SELECTPALETTE 48
CONSTANT: EMR_CREATEPALETTE 49
CONSTANT: EMR_SETPALETTEENTRIES 50
CONSTANT: EMR_RESIZEPALETTE 51
CONSTANT: EMR_REALIZEPALETTE 52
CONSTANT: EMR_EXTFLOODFILL 53
CONSTANT: EMR_LINETO 54
CONSTANT: EMR_ARCTO 55
CONSTANT: EMR_POLYDRAW 56
CONSTANT: EMR_SETARCDIRECTION 57
CONSTANT: EMR_SETMITERLIMIT 58
CONSTANT: EMR_BEGINPATH 59
CONSTANT: EMR_ENDPATH 60
CONSTANT: EMR_CLOSEFIGURE 61
CONSTANT: EMR_FILLPATH 62
CONSTANT: EMR_STROKEANDFILLPATH 63
CONSTANT: EMR_STROKEPATH 64
CONSTANT: EMR_FLATTENPATH 65
CONSTANT: EMR_WIDENPATH 66
CONSTANT: EMR_SELECTCLIPPATH 67
CONSTANT: EMR_ABORTPATH 68
CONSTANT: EMR_GDICOMMENT 70
CONSTANT: EMR_FILLRGN 71
CONSTANT: EMR_FRAMERGN 72
CONSTANT: EMR_INVERTRGN 73
CONSTANT: EMR_PAINTRGN 74
CONSTANT: EMR_EXTSELECTCLIPRGN 75
CONSTANT: EMR_BITBLT 76
CONSTANT: EMR_STRETCHBLT 77
CONSTANT: EMR_MASKBLT 78
CONSTANT: EMR_PLGBLT 79
CONSTANT: EMR_SETDIBITSTODEVICE 80
CONSTANT: EMR_STRETCHDIBITS 81
CONSTANT: EMR_EXTCREATEFONTINDIRECTW 82
CONSTANT: EMR_EXTTEXTOUTA 83
CONSTANT: EMR_EXTTEXTOUTW 84
CONSTANT: EMR_POLYBEZIER16 85
CONSTANT: EMR_POLYGON16 86
CONSTANT: EMR_POLYLINE16 87
CONSTANT: EMR_POLYBEZIERTO16 88
CONSTANT: EMR_POLYLINETO16 89
CONSTANT: EMR_POLYPOLYLINE16 90
CONSTANT: EMR_POLYPOLYGON16 91
CONSTANT: EMR_POLYDRAW16 92
CONSTANT: EMR_CREATEMONOBRUSH 93
CONSTANT: EMR_CREATEDIBPATTERNBRUSHPT 94
CONSTANT: EMR_EXTCREATEPEN 95
CONSTANT: EMR_POLYTEXTOUTA 96
CONSTANT: EMR_POLYTEXTOUTW 97
CONSTANT: EMR_SETICMMODE 98
CONSTANT: EMR_CREATECOLORSPACE 99
CONSTANT: EMR_SETCOLORSPACE 100
CONSTANT: EMR_DELETECOLORSPACE 101
CONSTANT: EMR_GLSRECORD 102
CONSTANT: EMR_GLSBOUNDEDRECORD 103
CONSTANT: EMR_PIXELFORMAT 104
CONSTANT: ENHMETA_SIGNATURE 1179469088
CONSTANT: EPS_SIGNATURE 0x46535045
CONSTANT: FR_PRIVATE 0x10
CONSTANT: FR_NOT_ENUM 0x20
CONSTANT: META_SETBKCOLOR 0x201
CONSTANT: META_SETBKMODE 0x102
CONSTANT: META_SETMAPMODE 0x103
CONSTANT: META_SETROP2 0x104
CONSTANT: META_SETRELABS 0x105
CONSTANT: META_SETPOLYFILLMODE 0x106
CONSTANT: META_SETSTRETCHBLTMODE 0x107
CONSTANT: META_SETTEXTCHAREXTRA 0x108
CONSTANT: META_SETTEXTCOLOR 0x209
CONSTANT: META_SETTEXTJUSTIFICATION 0x20A
CONSTANT: META_SETWINDOWORG 0x20B
CONSTANT: META_SETWINDOWEXT 0x20C
CONSTANT: META_SETVIEWPORTORG 0x20D
CONSTANT: META_SETVIEWPORTEXT 0x20E
CONSTANT: META_OFFSETWINDOWORG 0x20F
CONSTANT: META_SCALEWINDOWEXT 0x410
CONSTANT: META_OFFSETVIEWPORTORG 0x211
CONSTANT: META_SCALEVIEWPORTEXT 0x412
CONSTANT: META_LINETO 0x213
CONSTANT: META_MOVETO 0x214
CONSTANT: META_EXCLUDECLIPRECT 0x415
CONSTANT: META_INTERSECTCLIPRECT 0x416
CONSTANT: META_ARC 0x817
CONSTANT: META_ELLIPSE 0x418
CONSTANT: META_FLOODFILL 0x419
CONSTANT: META_PIE 0x81A
CONSTANT: META_RECTANGLE 0x41B
CONSTANT: META_ROUNDRECT 0x61C
CONSTANT: META_PATBLT 0x61D
CONSTANT: META_SAVEDC 0x1E
CONSTANT: META_SETPIXEL 0x41F
CONSTANT: META_OFFSETCLIPRGN 0x220
CONSTANT: META_TEXTOUT 0x521
CONSTANT: META_BITBLT 0x922
CONSTANT: META_STRETCHBLT 0xb23
CONSTANT: META_POLYGON 0x324
CONSTANT: META_POLYLINE 0x325
CONSTANT: META_ESCAPE 0x626
CONSTANT: META_RESTOREDC 0x127
CONSTANT: META_FILLREGION 0x228
CONSTANT: META_FRAMEREGION 0x429
CONSTANT: META_INVERTREGION 0x12A
CONSTANT: META_PAINTREGION 0x12B
CONSTANT: META_SELECTCLIPREGION 0x12C
CONSTANT: META_SELECTOBJECT 0x12D
CONSTANT: META_SETTEXTALIGN 0x12E
CONSTANT: META_CHORD 0x830
CONSTANT: META_SETMAPPERFLAGS 0x231
CONSTANT: META_EXTTEXTOUT 0xa32
CONSTANT: META_SETDIBTODEV 0xd33
CONSTANT: META_SELECTPALETTE 0x234
CONSTANT: META_REALIZEPALETTE 0x35
CONSTANT: META_ANIMATEPALETTE 0x436
CONSTANT: META_SETPALENTRIES 0x37
CONSTANT: META_POLYPOLYGON 0x538
CONSTANT: META_RESIZEPALETTE 0x139
CONSTANT: META_DIBBITBLT 0x940
CONSTANT: META_DIBSTRETCHBLT 0xb41
CONSTANT: META_DIBCREATEPATTERNBRUSH 0x142
CONSTANT: META_STRETCHDIB 0xf43
CONSTANT: META_EXTFLOODFILL 0x548
CONSTANT: META_DELETEOBJECT 0x1f0
CONSTANT: META_CREATEPALETTE 0xf7
CONSTANT: META_CREATEPATTERNBRUSH 0x1F9
CONSTANT: META_CREATEPENINDIRECT 0x2FA
CONSTANT: META_CREATEFONTINDIRECT 0x2FB
CONSTANT: META_CREATEBRUSHINDIRECT 0x2FC
CONSTANT: META_CREATEREGION 0x6FF
CONSTANT: ELF_VENDOR_SIZE 4
CONSTANT: ELF_VERSION 0
CONSTANT: ELF_CULTURE_LATIN 0
CONSTANT: PFD_TYPE_RGBA 0
CONSTANT: PFD_TYPE_COLORINDEX 1
CONSTANT: PFD_MAIN_PLANE 0
CONSTANT: PFD_OVERLAY_PLANE 1
CONSTANT: PFD_UNDERLAY_PLANE -1
CONSTANT: PFD_DOUBLEBUFFER 1
CONSTANT: PFD_STEREO 2
CONSTANT: PFD_DRAW_TO_WINDOW 4
CONSTANT: PFD_DRAW_TO_BITMAP 8
CONSTANT: PFD_SUPPORT_GDI 16
CONSTANT: PFD_SUPPORT_OPENGL 32
CONSTANT: PFD_SUPPORT_DIRECTDRAW 8192
CONSTANT: PFD_GENERIC_FORMAT 64
CONSTANT: PFD_NEED_PALETTE 128
CONSTANT: PFD_NEED_SYSTEM_PALETTE 0x00000100
CONSTANT: PFD_SWAP_EXCHANGE 0x00000200
CONSTANT: PFD_SWAP_COPY 0x00000400
CONSTANT: PFD_SWAP_LAYER_BUFFERS 0x00000800
CONSTANT: PFD_GENERIC_ACCELERATED 0x00001000
CONSTANT: PFD_DEPTH_DONTCARE 0x20000000
CONSTANT: PFD_DOUBLEBUFFER_DONTCARE 0x40000000
CONSTANT: PFD_STEREO_DONTCARE 0x80000000
CONSTANT: SP_ERROR -1
CONSTANT: SP_OUTOFDISK -4
CONSTANT: SP_OUTOFMEMORY -5
CONSTANT: SP_USERABORT -3
CONSTANT: SP_APPABORT -2
CONSTANT: BLACKNESS 0x00000042
CONSTANT: NOTSRCERASE 0x001100A6
CONSTANT: NOTSRCCOPY 0x00330008
CONSTANT: SRCERASE 0x00440328
CONSTANT: DSTINVERT 0x00550009
CONSTANT: PATINVERT 0x005A0049
CONSTANT: SRCINVERT 0x00660046
CONSTANT: SRCAND 0x008800C6
CONSTANT: MERGEPAINT 0x00BB0226
CONSTANT: MERGECOPY 0x00C000CA
CONSTANT: SRCCOPY 0x00CC0020
CONSTANT: SRCPAINT 0x00EE0086
CONSTANT: PATCOPY 0x00F00021
CONSTANT: PATPAINT 0x00FB0A09
CONSTANT: WHITENESS 0x00FF0062
CONSTANT: CAPTUREBLT 0x40000000
CONSTANT: NOMIRRORBITMAP 0x80000000
CONSTANT: R2_BLACK 1
CONSTANT: R2_COPYPEN 13
CONSTANT: R2_MASKNOTPEN 3
CONSTANT: R2_MASKPEN 9
CONSTANT: R2_MASKPENNOT 5
CONSTANT: R2_MERGENOTPEN 12
CONSTANT: R2_MERGEPEN 15
CONSTANT: R2_MERGEPENNOT 14
CONSTANT: R2_NOP 11
CONSTANT: R2_NOT 6
CONSTANT: R2_NOTCOPYPEN 4
CONSTANT: R2_NOTMASKPEN 8
CONSTANT: R2_NOTMERGEPEN 2
CONSTANT: R2_NOTXORPEN 10
CONSTANT: R2_WHITE 16
CONSTANT: R2_XORPEN 7
CONSTANT: CM_OUT_OF_GAMUT 255
CONSTANT: CM_IN_GAMUT 0
CONSTANT: RGN_AND 1
CONSTANT: RGN_COPY 5
CONSTANT: RGN_DIFF 4
CONSTANT: RGN_OR 2
CONSTANT: RGN_XOR 3
CONSTANT: NULLREGION 1
CONSTANT: SIMPLEREGION 2
CONSTANT: COMPLEXREGION 3
CONSTANT: ERROR 0
CONSTANT: CBM_INIT 4
CONSTANT: DIB_PAL_COLORS 1
CONSTANT: DIB_RGB_COLORS 0
CONSTANT: FW_DONTCARE 0
CONSTANT: FW_THIN 100
CONSTANT: FW_EXTRALIGHT 200
ALIAS: FW_ULTRALIGHT FW_EXTRALIGHT
CONSTANT: FW_LIGHT 300
CONSTANT: FW_NORMAL 400
CONSTANT: FW_REGULAR 400
CONSTANT: FW_MEDIUM 500
CONSTANT: FW_SEMIBOLD 600
ALIAS: FW_DEMIBOLD FW_SEMIBOLD
CONSTANT: FW_BOLD 700
CONSTANT: FW_EXTRABOLD 800
ALIAS: FW_ULTRABOLD FW_EXTRABOLD
CONSTANT: FW_HEAVY 900
ALIAS: FW_BLACK FW_HEAVY
CONSTANT: ANSI_CHARSET 0
CONSTANT: DEFAULT_CHARSET 1
CONSTANT: SYMBOL_CHARSET 2
CONSTANT: SHIFTJIS_CHARSET 128
CONSTANT: HANGEUL_CHARSET 129
CONSTANT: HANGUL_CHARSET 129
CONSTANT: GB2312_CHARSET 134
CONSTANT: CHINESEBIG5_CHARSET 136
CONSTANT: GREEK_CHARSET 161
CONSTANT: TURKISH_CHARSET 162
CONSTANT: HEBREW_CHARSET 177
CONSTANT: ARABIC_CHARSET 178
CONSTANT: BALTIC_CHARSET 186
CONSTANT: RUSSIAN_CHARSET 204
CONSTANT: THAI_CHARSET 222
CONSTANT: EASTEUROPE_CHARSET 238
CONSTANT: OEM_CHARSET 255
CONSTANT: JOHAB_CHARSET 130
CONSTANT: VIETNAMESE_CHARSET 163
CONSTANT: MAC_CHARSET 77
CONSTANT: OUT_DEFAULT_PRECIS 0
CONSTANT: OUT_STRING_PRECIS 1
CONSTANT: OUT_CHARACTER_PRECIS 2
CONSTANT: OUT_STROKE_PRECIS 3
CONSTANT: OUT_TT_PRECIS 4
CONSTANT: OUT_DEVICE_PRECIS 5
CONSTANT: OUT_RASTER_PRECIS 6
CONSTANT: OUT_TT_ONLY_PRECIS 7
CONSTANT: OUT_OUTLINE_PRECIS 8
CONSTANT: CLIP_DEFAULT_PRECIS 0
CONSTANT: CLIP_CHARACTER_PRECIS 1
CONSTANT: CLIP_STROKE_PRECIS 2
CONSTANT: CLIP_MASK 15
CONSTANT: CLIP_LH_ANGLES 16
CONSTANT: CLIP_TT_ALWAYS 32
CONSTANT: CLIP_EMBEDDED 128
CONSTANT: DEFAULT_QUALITY 0
CONSTANT: DRAFT_QUALITY 1
CONSTANT: PROOF_QUALITY 2
CONSTANT: NONANTIALIASED_QUALITY 3
CONSTANT: ANTIALIASED_QUALITY 4
CONSTANT: DEFAULT_PITCH 0
CONSTANT: FIXED_PITCH 1
CONSTANT: VARIABLE_PITCH 2
CONSTANT: MONO_FONT 8
CONSTANT: FF_DECORATIVE 80
CONSTANT: FF_DONTCARE 0
CONSTANT: FF_MODERN 48
CONSTANT: FF_ROMAN 16
CONSTANT: FF_SCRIPT 64
CONSTANT: FF_SWISS 32
CONSTANT: PANOSE_COUNT 10
CONSTANT: PAN_FAMILYTYPE_INDEX 0
CONSTANT: PAN_SERIFSTYLE_INDEX 1
CONSTANT: PAN_WEIGHT_INDEX 2
CONSTANT: PAN_PROPORTION_INDEX 3
CONSTANT: PAN_CONTRAST_INDEX 4
CONSTANT: PAN_STROKEVARIATION_INDEX 5
CONSTANT: PAN_ARMSTYLE_INDEX 6
CONSTANT: PAN_LETTERFORM_INDEX 7
CONSTANT: PAN_MIDLINE_INDEX 8
CONSTANT: PAN_XHEIGHT_INDEX 9
CONSTANT: PAN_CULTURE_LATIN 0
CONSTANT: PAN_ANY 0
CONSTANT: PAN_NO_FIT 1
CONSTANT: PAN_FAMILY_TEXT_DISPLAY 2
CONSTANT: PAN_FAMILY_SCRIPT 3
CONSTANT: PAN_FAMILY_DECORATIVE 4
CONSTANT: PAN_FAMILY_PICTORIAL 5
CONSTANT: PAN_SERIF_COVE 2
CONSTANT: PAN_SERIF_OBTUSE_COVE 3
CONSTANT: PAN_SERIF_SQUARE_COVE 4
CONSTANT: PAN_SERIF_OBTUSE_SQUARE_COVE 5
CONSTANT: PAN_SERIF_SQUARE 6
CONSTANT: PAN_SERIF_THIN 7
CONSTANT: PAN_SERIF_BONE 8
CONSTANT: PAN_SERIF_EXAGGERATED 9
CONSTANT: PAN_SERIF_TRIANGLE 10
CONSTANT: PAN_SERIF_NORMAL_SANS 11
CONSTANT: PAN_SERIF_OBTUSE_SANS 12
CONSTANT: PAN_SERIF_PERP_SANS 13
CONSTANT: PAN_SERIF_FLARED 14
CONSTANT: PAN_SERIF_ROUNDED 15
CONSTANT: PAN_WEIGHT_VERY_LIGHT 2
CONSTANT: PAN_WEIGHT_LIGHT 3
CONSTANT: PAN_WEIGHT_THIN 4
CONSTANT: PAN_WEIGHT_BOOK 5
CONSTANT: PAN_WEIGHT_MEDIUM 6
CONSTANT: PAN_WEIGHT_DEMI 7
CONSTANT: PAN_WEIGHT_BOLD 8
CONSTANT: PAN_WEIGHT_HEAVY 9
CONSTANT: PAN_WEIGHT_BLACK 10
CONSTANT: PAN_WEIGHT_NORD 11
CONSTANT: PAN_PROP_OLD_STYLE 2
CONSTANT: PAN_PROP_MODERN 3
CONSTANT: PAN_PROP_EVEN_WIDTH 4
CONSTANT: PAN_PROP_EXPANDED 5
CONSTANT: PAN_PROP_CONDENSED 6
CONSTANT: PAN_PROP_VERY_EXPANDED 7
CONSTANT: PAN_PROP_VERY_CONDENSED 8
CONSTANT: PAN_PROP_MONOSPACED 9
CONSTANT: PAN_CONTRAST_NONE 2
CONSTANT: PAN_CONTRAST_VERY_LOW 3
CONSTANT: PAN_CONTRAST_LOW 4
CONSTANT: PAN_CONTRAST_MEDIUM_LOW 5
CONSTANT: PAN_CONTRAST_MEDIUM 6
CONSTANT: PAN_CONTRAST_MEDIUM_HIGH 7
CONSTANT: PAN_CONTRAST_HIGH 8
CONSTANT: PAN_CONTRAST_VERY_HIGH 9
CONSTANT: PAN_STROKE_GRADUAL_DIAG 2
CONSTANT: PAN_STROKE_GRADUAL_TRAN 3
CONSTANT: PAN_STROKE_GRADUAL_VERT 4
CONSTANT: PAN_STROKE_GRADUAL_HORZ 5
CONSTANT: PAN_STROKE_RAPID_VERT 6
CONSTANT: PAN_STROKE_RAPID_HORZ 7
CONSTANT: PAN_STROKE_INSTANT_VERT 8
CONSTANT: PAN_STRAIGHT_ARMS_HORZ 2
CONSTANT: PAN_STRAIGHT_ARMS_WEDGE 3
CONSTANT: PAN_STRAIGHT_ARMS_VERT 4
CONSTANT: PAN_STRAIGHT_ARMS_SINGLE_SERIF 5
CONSTANT: PAN_STRAIGHT_ARMS_DOUBLE_SERIF 6
CONSTANT: PAN_BENT_ARMS_HORZ 7
CONSTANT: PAN_BENT_ARMS_WEDGE 8
CONSTANT: PAN_BENT_ARMS_VERT 9
CONSTANT: PAN_BENT_ARMS_SINGLE_SERIF 10
CONSTANT: PAN_BENT_ARMS_DOUBLE_SERIF 11
CONSTANT: PAN_LETT_NORMAL_CONTACT 2
CONSTANT: PAN_LETT_NORMAL_WEIGHTED 3
CONSTANT: PAN_LETT_NORMAL_BOXED 4
CONSTANT: PAN_LETT_NORMAL_FLATTENED 5
CONSTANT: PAN_LETT_NORMAL_ROUNDED 6
CONSTANT: PAN_LETT_NORMAL_OFF_CENTER 7
CONSTANT: PAN_LETT_NORMAL_SQUARE 8
CONSTANT: PAN_LETT_OBLIQUE_CONTACT 9
CONSTANT: PAN_LETT_OBLIQUE_WEIGHTED 10
CONSTANT: PAN_LETT_OBLIQUE_BOXED 11
CONSTANT: PAN_LETT_OBLIQUE_FLATTENED 12
CONSTANT: PAN_LETT_OBLIQUE_ROUNDED 13
CONSTANT: PAN_LETT_OBLIQUE_OFF_CENTER 14
CONSTANT: PAN_LETT_OBLIQUE_SQUARE 15
CONSTANT: PAN_MIDLINE_STANDARD_TRIMMED 2
CONSTANT: PAN_MIDLINE_STANDARD_POINTED 3
CONSTANT: PAN_MIDLINE_STANDARD_SERIFED 4
CONSTANT: PAN_MIDLINE_HIGH_TRIMMED 5
CONSTANT: PAN_MIDLINE_HIGH_POINTED 6
CONSTANT: PAN_MIDLINE_HIGH_SERIFED 7
CONSTANT: PAN_MIDLINE_CONSTANT_TRIMMED 8
CONSTANT: PAN_MIDLINE_CONSTANT_POINTED 9
CONSTANT: PAN_MIDLINE_CONSTANT_SERIFED 10
CONSTANT: PAN_MIDLINE_LOW_TRIMMED 11
CONSTANT: PAN_MIDLINE_LOW_POINTED 12
CONSTANT: PAN_MIDLINE_LOW_SERIFED 13
CONSTANT: PAN_XHEIGHT_CONSTANT_SMALL 2
CONSTANT: PAN_XHEIGHT_CONSTANT_STD 3
CONSTANT: PAN_XHEIGHT_CONSTANT_LARGE 4
CONSTANT: PAN_XHEIGHT_DUCKING_SMALL 5
CONSTANT: PAN_XHEIGHT_DUCKING_STD 6
CONSTANT: PAN_XHEIGHT_DUCKING_LARGE 7
CONSTANT: FS_LATIN1 1
CONSTANT: FS_LATIN2 2
CONSTANT: FS_CYRILLIC 4
CONSTANT: FS_GREEK 8
CONSTANT: FS_TURKISH 16
CONSTANT: FS_HEBREW 32
CONSTANT: FS_ARABIC 64
CONSTANT: FS_BALTIC 128
CONSTANT: FS_THAI 0x10000
CONSTANT: FS_JISJAPAN 0x20000
CONSTANT: FS_CHINESESIMP 0x40000
CONSTANT: FS_WANSUNG 0x80000
CONSTANT: FS_CHINESETRAD 0x100000
CONSTANT: FS_JOHAB 0x200000
CONSTANT: FS_SYMBOL 0x80000000
CONSTANT: HS_BDIAGONAL 3
CONSTANT: HS_CROSS 4
CONSTANT: HS_DIAGCROSS 5
CONSTANT: HS_FDIAGONAL 2
CONSTANT: HS_HORIZONTAL 0
CONSTANT: HS_VERTICAL 1
CONSTANT: PS_GEOMETRIC 65536
CONSTANT: PS_COSMETIC 0
CONSTANT: PS_ALTERNATE 8
CONSTANT: PS_SOLID 0
CONSTANT: PS_DASH 1
CONSTANT: PS_DOT 2
CONSTANT: PS_DASHDOT 3
CONSTANT: PS_DASHDOTDOT 4
CONSTANT: PS_NULL 5
CONSTANT: PS_USERSTYLE 7
CONSTANT: PS_INSIDEFRAME 6
CONSTANT: PS_ENDCAP_ROUND 0
CONSTANT: PS_ENDCAP_SQUARE 256
CONSTANT: PS_ENDCAP_FLAT 512
CONSTANT: PS_JOIN_BEVEL 4096
CONSTANT: PS_JOIN_MITER 8192
CONSTANT: PS_JOIN_ROUND 0
CONSTANT: PS_STYLE_MASK 15
CONSTANT: PS_ENDCAP_MASK 3840
CONSTANT: PS_TYPE_MASK 983040
CONSTANT: ALTERNATE 1
CONSTANT: WINDING 2
CONSTANT: DC_BINNAMES 12
CONSTANT: DC_BINS 6
CONSTANT: DC_COPIES 18
CONSTANT: DC_DRIVER 11
CONSTANT: DC_DATATYPE_PRODUCED 21
CONSTANT: DC_DUPLEX 7
CONSTANT: DC_EMF_COMPLIANT 20
CONSTANT: DC_ENUMRESOLUTIONS 13
CONSTANT: DC_EXTRA 9
CONSTANT: DC_FIELDS 1
CONSTANT: DC_FILEDEPENDENCIES 14
CONSTANT: DC_MAXEXTENT 5
CONSTANT: DC_MINEXTENT 4
CONSTANT: DC_ORIENTATION 17
CONSTANT: DC_PAPERNAMES 16
CONSTANT: DC_PAPERS 2
CONSTANT: DC_PAPERSIZE 3
CONSTANT: DC_SIZE 8
CONSTANT: DC_TRUETYPE 15
CONSTANT: DCTT_BITMAP 1
CONSTANT: DCTT_DOWNLOAD 2
CONSTANT: DCTT_SUBDEV 4
CONSTANT: DCTT_DOWNLOAD_OUTLINE 8
CONSTANT: DC_VERSION 10
CONSTANT: DC_BINADJUST 19
CONSTANT: DC_MANUFACTURER 23
CONSTANT: DC_MODEL 24
CONSTANT: DC_PERSONALITY 25
CONSTANT: DC_PRINTRATE 26
CONSTANT: DC_PRINTRATEUNIT 27
CONSTANT: DC_PRINTERMEM 28
CONSTANT: DC_MEDIAREADY 29
CONSTANT: DC_STAPLE 30
CONSTANT: DC_PRINTRATEPPM 31
CONSTANT: DC_COLORDEVICE 32
CONSTANT: DC_NUP 33
CONSTANT: DC_MEDIATYPENAMES 34
CONSTANT: DC_MEDIATYPES 35
CONSTANT: DCBA_FACEUPNONE 0
CONSTANT: DCBA_FACEUPCENTER 1
CONSTANT: DCBA_FACEUPLEFT 2
CONSTANT: DCBA_FACEUPRIGHT 3
CONSTANT: DCBA_FACEDOWNNONE 256
CONSTANT: DCBA_FACEDOWNCENTER 257
CONSTANT: DCBA_FACEDOWNLEFT 258
CONSTANT: DCBA_FACEDOWNRIGHT 259
CONSTANT: FLOODFILLBORDER 0
CONSTANT: FLOODFILLSURFACE 1
CONSTANT: ETO_CLIPPED 0x0004
CONSTANT: ETO_GLYPH_INDEX 0x0010
CONSTANT: ETO_OPAQUE 0x0002
CONSTANT: ETO_NUMERICSLATIN 0x0800
CONSTANT: ETO_NUMERICSLOCAL 0x0400
CONSTANT: ETO_RTLREADING 0x0080
CONSTANT: ETO_IGNORELANGUAGE 0x1000
CONSTANT: ETO_PDY 0x2000
CONSTANT: GDICOMMENT_WINDOWS_METAFILE -2147483647
CONSTANT: GDICOMMENT_BEGINGROUP 2
CONSTANT: GDICOMMENT_ENDGROUP 3
CONSTANT: GDICOMMENT_MULTIFORMATS 1073741828
CONSTANT: GDICOMMENT_IDENTIFIER 1128875079
CONSTANT: AD_COUNTERCLOCKWISE 1
CONSTANT: AD_CLOCKWISE 2
CONSTANT: RDH_RECTANGLES 1
CONSTANT: GCPCLASS_LATIN 1
CONSTANT: GCPCLASS_HEBREW 2
CONSTANT: GCPCLASS_ARABIC 2
CONSTANT: GCPCLASS_NEUTRAL 3
CONSTANT: GCPCLASS_LOCALNUMBER 4
CONSTANT: GCPCLASS_LATINNUMBER 5
CONSTANT: GCPCLASS_LATINNUMERICTERMINATOR 6
CONSTANT: GCPCLASS_LATINNUMERICSEPARATOR 7
CONSTANT: GCPCLASS_NUMERICSEPARATOR 8
CONSTANT: GCPCLASS_PREBOUNDLTR 128
CONSTANT: GCPCLASS_PREBOUNDRTL 64
CONSTANT: GCPCLASS_POSTBOUNDLTR 32
CONSTANT: GCPCLASS_POSTBOUNDRTL 16
CONSTANT: GCPGLYPH_LINKBEFORE 0x8000
CONSTANT: GCPGLYPH_LINKAFTER 0x4000
CONSTANT: DCB_DISABLE 8
CONSTANT: DCB_ENABLE 4
CONSTANT: DCB_RESET 1
CONSTANT: DCB_SET 3
CONSTANT: DCB_ACCUMULATE 2
CONSTANT: DCB_DIRTY 2
CONSTANT: OBJ_BRUSH 2
CONSTANT: OBJ_PEN 1
CONSTANT: OBJ_PAL 5
CONSTANT: OBJ_FONT 6
CONSTANT: OBJ_BITMAP 7
CONSTANT: OBJ_EXTPEN 11
CONSTANT: OBJ_REGION 8
CONSTANT: OBJ_DC 3
CONSTANT: OBJ_MEMDC 10
CONSTANT: OBJ_METAFILE 9
CONSTANT: OBJ_METADC 4
CONSTANT: OBJ_ENHMETAFILE 13
CONSTANT: OBJ_ENHMETADC 12
CONSTANT: DRIVERVERSION 0
CONSTANT: TECHNOLOGY 2
CONSTANT: DT_PLOTTER 0
CONSTANT: DT_RASDISPLAY 1
CONSTANT: DT_RASPRINTER 2
CONSTANT: DT_RASCAMERA 3
CONSTANT: DT_CHARSTREAM 4
CONSTANT: DT_METAFILE 5
CONSTANT: DT_DISPFILE 6
CONSTANT: HORZSIZE 4
CONSTANT: VERTSIZE 6
CONSTANT: HORZRES 8
CONSTANT: VERTRES 10
CONSTANT: LOGPIXELSX 88
CONSTANT: LOGPIXELSY 90
CONSTANT: BITSPIXEL 12
CONSTANT: PLANES 14
CONSTANT: NUMBRUSHES 16
CONSTANT: NUMPENS 18
CONSTANT: NUMFONTS 22
CONSTANT: NUMCOLORS 24
CONSTANT: NUMMARKERS 20
CONSTANT: ASPECTX 40
CONSTANT: ASPECTY 42
CONSTANT: ASPECTXY 44
CONSTANT: PDEVICESIZE 26
CONSTANT: CLIPCAPS 36
CONSTANT: SIZEPALETTE 104
CONSTANT: NUMRESERVED 106
CONSTANT: COLORRES 108
CONSTANT: PHYSICALWIDTH 110
CONSTANT: PHYSICALHEIGHT 111
CONSTANT: PHYSICALOFFSETX 112
CONSTANT: PHYSICALOFFSETY 113
CONSTANT: SCALINGFACTORX 114
CONSTANT: SCALINGFACTORY 115
CONSTANT: VREFRESH 116
CONSTANT: DESKTOPHORZRES 118
CONSTANT: DESKTOPVERTRES 117
CONSTANT: BLTALIGNMENT 119
CONSTANT: SHADEBLENDCAPS 120
CONSTANT: SB_NONE 0x00
CONSTANT: SB_CONST_ALPHA 0x01
CONSTANT: SB_PIXEL_ALPHA 0x02
CONSTANT: SB_PREMULT_ALPHA 0x04
CONSTANT: SB_GRAD_RECT 0x10
CONSTANT: SB_GRAD_TRI 0x20
CONSTANT: COLORMGMTCAPS 121
CONSTANT: CM_NONE 0x00
CONSTANT: CM_DEVICE_ICM 0x01
CONSTANT: CM_GAMMA_RAMP 0x02
CONSTANT: CM_CMYK_COLOR 0x04
CONSTANT: RASTERCAPS 38
CONSTANT: RC_BITBLT 1
CONSTANT: RC_BITMAP64 8
CONSTANT: RC_DI_BITMAP 128
CONSTANT: RC_DIBTODEV 512
CONSTANT: RC_FLOODFILL 4096
CONSTANT: RC_STRETCHBLT 2048
CONSTANT: RC_STRETCHDIB 8192
CONSTANT: CURVECAPS 28
CONSTANT: CC_NONE 0
CONSTANT: CC_CIRCLES 1
CONSTANT: CC_PIE 2
CONSTANT: CC_CHORD 4
CONSTANT: CC_ELLIPSES 8
CONSTANT: CC_WIDE 16
CONSTANT: CC_STYLED 32
CONSTANT: CC_WIDESTYLED 64
CONSTANT: CC_INTERIORS 128
CONSTANT: CC_ROUNDRECT 256
CONSTANT: LINECAPS 30
CONSTANT: LC_NONE 0
CONSTANT: LC_POLYLINE 2
CONSTANT: LC_MARKER 4
CONSTANT: LC_POLYMARKER 8
CONSTANT: LC_WIDE 16
CONSTANT: LC_STYLED 32
CONSTANT: LC_WIDESTYLED 64
CONSTANT: LC_INTERIORS 128
CONSTANT: POLYGONALCAPS 32
CONSTANT: RC_BANDING 2
CONSTANT: RC_BIGFONT 1024
CONSTANT: RC_DEVBITS 0x8000
CONSTANT: RC_GDI20_OUTPUT 16
CONSTANT: RC_GDI20_STATE 32
CONSTANT: RC_NONE 0
CONSTANT: RC_OP_DX_OUTPUT 0x4000
CONSTANT: RC_PALETTE 256
CONSTANT: RC_SAVEBITMAP 64
CONSTANT: RC_SCALING 4
CONSTANT: PC_NONE 0
CONSTANT: PC_POLYGON 1
CONSTANT: PC_POLYPOLYGON 256
CONSTANT: PC_PATHS 512
CONSTANT: PC_RECTANGLE 2
CONSTANT: PC_WINDPOLYGON 4
CONSTANT: PC_SCANLINE 8
CONSTANT: PC_TRAPEZOID 4
CONSTANT: PC_WIDE 16
CONSTANT: PC_STYLED 32
CONSTANT: PC_WIDESTYLED 64
CONSTANT: PC_INTERIORS 128
CONSTANT: TEXTCAPS 34
CONSTANT: TC_OP_CHARACTER 1
CONSTANT: TC_OP_STROKE 2
CONSTANT: TC_CP_STROKE 4
CONSTANT: TC_CR_90 8
CONSTANT: TC_CR_ANY 16
CONSTANT: TC_SF_X_YINDEP 32
CONSTANT: TC_SA_DOUBLE 64
CONSTANT: TC_SA_INTEGER 128
CONSTANT: TC_SA_CONTIN 256
CONSTANT: TC_EA_DOUBLE 512
CONSTANT: TC_IA_ABLE 1024
CONSTANT: TC_UA_ABLE 2048
CONSTANT: TC_SO_ABLE 4096
CONSTANT: TC_RA_ABLE 8192
CONSTANT: TC_VA_ABLE 16384
CONSTANT: TC_RESERVED 32768
CONSTANT: TC_SCROLLBLT 65536
CONSTANT: GCP_DBCS 1
CONSTANT: GCP_ERROR 0x8000
CONSTANT: GCP_CLASSIN 0x80000
CONSTANT: GCP_DIACRITIC 256
CONSTANT: GCP_DISPLAYZWG 0x400000
CONSTANT: GCP_GLYPHSHAPE 16
CONSTANT: GCP_JUSTIFY 0x10000
CONSTANT: GCP_JUSTIFYIN 0x200000
CONSTANT: GCP_KASHIDA 1024
CONSTANT: GCP_LIGATE 32
CONSTANT: GCP_MAXEXTENT 0x100000
CONSTANT: GCP_NEUTRALOVERRIDE 0x2000000
CONSTANT: GCP_NUMERICOVERRIDE 0x1000000
CONSTANT: GCP_NUMERICSLATIN 0x4000000
CONSTANT: GCP_NUMERICSLOCAL 0x8000000
CONSTANT: GCP_REORDER 2
CONSTANT: GCP_SYMSWAPOFF 0x800000
CONSTANT: GCP_USEKERNING 8
CONSTANT: FLI_GLYPHS 0x40000
CONSTANT: FLI_MASK 0x103b
CONSTANT: GGO_METRICS 0
CONSTANT: GGO_BITMAP 1
CONSTANT: GGO_NATIVE 2
CONSTANT: GGO_BEZIER 3
CONSTANT: GGO_GRAY2_BITMAP 4
CONSTANT: GGO_GRAY4_BITMAP 5
CONSTANT: GGO_GRAY8_BITMAP 6
CONSTANT: GGO_GLYPH_INDEX 128
CONSTANT: GGO_UNHINTED 256
CONSTANT: GM_COMPATIBLE 1
CONSTANT: GM_ADVANCED 2
CONSTANT: MM_ANISOTROPIC 8
CONSTANT: MM_HIENGLISH 5
CONSTANT: MM_HIMETRIC 3
CONSTANT: MM_ISOTROPIC 7
CONSTANT: MM_LOENGLISH 4
CONSTANT: MM_LOMETRIC 2
CONSTANT: MM_TEXT 1
CONSTANT: MM_TWIPS 6
ALIAS: MM_MAX_FIXEDSCALE MM_TWIPS
CONSTANT: ABSOLUTE 1
CONSTANT: RELATIVE 2
CONSTANT: PC_EXPLICIT 2
CONSTANT: PC_NOCOLLAPSE 4
CONSTANT: PC_RESERVED 1
CONSTANT: CLR_NONE 0xffffffff
ALIAS: CLR_INVALID CLR_NONE
CONSTANT: CLR_DEFAULT 0xff000000
CONSTANT: PT_MOVETO 6
CONSTANT: PT_LINETO 2
CONSTANT: PT_BEZIERTO 4
CONSTANT: PT_CLOSEFIGURE 1
CONSTANT: TT_AVAILABLE 1
CONSTANT: TT_ENABLED 2
CONSTANT: BLACK_BRUSH 4
CONSTANT: DKGRAY_BRUSH 3
CONSTANT: GRAY_BRUSH 2
CONSTANT: HOLLOW_BRUSH 5
CONSTANT: LTGRAY_BRUSH 1
CONSTANT: NULL_BRUSH 5
CONSTANT: WHITE_BRUSH 0
CONSTANT: BLACK_PEN 7
CONSTANT: NULL_PEN 8
CONSTANT: WHITE_PEN 6
CONSTANT: ANSI_FIXED_FONT 11
CONSTANT: ANSI_VAR_FONT 12
CONSTANT: DEVICE_DEFAULT_FONT 14
CONSTANT: DEFAULT_GUI_FONT 17
CONSTANT: OEM_FIXED_FONT 10
CONSTANT: SYSTEM_FONT 13
CONSTANT: SYSTEM_FIXED_FONT 16
CONSTANT: DEFAULT_PALETTE 15
CONSTANT: DC_BRUSH 18
CONSTANT: DC_PEN 19
CONSTANT: SYSPAL_ERROR 0
CONSTANT: SYSPAL_STATIC 1
CONSTANT: SYSPAL_NOSTATIC 2
CONSTANT: SYSPAL_NOSTATIC256 3 
CONSTANT: TA_BASELINE 24
CONSTANT: TA_BOTTOM 8
CONSTANT: TA_TOP 0
CONSTANT: TA_CENTER 6
CONSTANT: TA_LEFT 0
CONSTANT: TA_RIGHT 2
CONSTANT: TA_RTLREADING 256
CONSTANT: TA_NOUPDATECP 0
CONSTANT: TA_UPDATECP 1
CONSTANT: TA_MASK flags{ TA_BASELINE TA_CENTER TA_UPDATECP TA_RTLREADING }
CONSTANT: VTA_BASELINE 24
CONSTANT: VTA_CENTER 6
ALIAS: VTA_LEFT TA_BOTTOM
ALIAS: VTA_RIGHT TA_TOP
ALIAS: VTA_BOTTOM TA_RIGHT
ALIAS: VTA_TOP TA_LEFT
CONSTANT: MWT_IDENTITY 1
CONSTANT: MWT_LEFTMULTIPLY 2
CONSTANT: MWT_RIGHTMULTIPLY 3
CONSTANT: OPAQUE 2
CONSTANT: TRANSPARENT 1
CONSTANT: BLACKONWHITE 1
CONSTANT: WHITEONBLACK 2
CONSTANT: COLORONCOLOR 3
CONSTANT: HALFTONE 4
CONSTANT: MAXSTRETCHBLTMODE 4
CONSTANT: STRETCH_ANDSCANS 1
CONSTANT: STRETCH_DELETESCANS 3
CONSTANT: STRETCH_HALFTONE 4
CONSTANT: STRETCH_ORSCANS 2
CONSTANT: TCI_SRCCHARSET 1
CONSTANT: TCI_SRCCODEPAGE 2
CONSTANT: TCI_SRCFONTSIG 3
CONSTANT: ICM_ON 2
CONSTANT: ICM_OFF 1
CONSTANT: ICM_QUERY 3
CONSTANT: NEWFRAME 1
CONSTANT: ABORTDOC 2
CONSTANT: NEXTBAND 3
CONSTANT: SETCOLORTABLE 4
CONSTANT: GETCOLORTABLE 5
CONSTANT: FLUSHOUTPUT 6
CONSTANT: DRAFTMODE 7
CONSTANT: QUERYESCSUPPORT 8
CONSTANT: SETABORTPROC 9
CONSTANT: STARTDOC 10
CONSTANT: ENDDOC 11
CONSTANT: GETPHYSPAGESIZE 12
CONSTANT: GETPRINTINGOFFSET 13
CONSTANT: GETSCALINGFACTOR 14
CONSTANT: MFCOMMENT 15
CONSTANT: GETPENWIDTH 16
CONSTANT: SETCOPYCOUNT 17
CONSTANT: SELECTPAPERSOURCE 18
CONSTANT: DEVICEDATA 19
CONSTANT: PASSTHROUGH 19
CONSTANT: GETTECHNOLGY 20
CONSTANT: GETTECHNOLOGY 20
CONSTANT: SETLINECAP 21
CONSTANT: SETLINEJOIN 22
CONSTANT: SETMITERLIMIT 23
CONSTANT: BANDINFO 24
CONSTANT: DRAWPATTERNRECT 25
CONSTANT: GETVECTORPENSIZE 26
CONSTANT: GETVECTORBRUSHSIZE 27
CONSTANT: ENABLEDUPLEX 28
CONSTANT: GETSETPAPERBINS 29
CONSTANT: GETSETPRINTORIENT 30
CONSTANT: ENUMPAPERBINS 31
CONSTANT: SETDIBSCALING 32
CONSTANT: EPSPRINTING 33
CONSTANT: ENUMPAPERMETRICS 34
CONSTANT: GETSETPAPERMETRICS 35
CONSTANT: POSTSCRIPT_DATA 37
CONSTANT: POSTSCRIPT_IGNORE 38
CONSTANT: MOUSETRAILS 39
CONSTANT: GETDEVICEUNITS 42
CONSTANT: GETEXTENDEDTEXTMETRICS 256
CONSTANT: GETEXTENTTABLE 257
CONSTANT: GETPAIRKERNTABLE 258
CONSTANT: GETTRACKKERNTABLE 259
CONSTANT: EXTTEXTOUT 512
CONSTANT: GETFACENAME 513
CONSTANT: DOWNLOADFACE 514
CONSTANT: ENABLERELATIVEWIDTHS 768
CONSTANT: ENABLEPAIRKERNING 769
CONSTANT: SETKERNTRACK 770
CONSTANT: SETALLJUSTVALUES 771
CONSTANT: SETCHARSET 772
CONSTANT: STRETCHBLT 2048
CONSTANT: GETSETSCREENPARAMS 3072
CONSTANT: QUERYDIBSUPPORT 3073
CONSTANT: BEGIN_PATH 4096
CONSTANT: CLIP_TO_PATH 4097
CONSTANT: END_PATH 4098
CONSTANT: EXT_DEVICE_CAPS 4099
CONSTANT: RESTORE_CTM 4100
CONSTANT: SAVE_CTM 4101
CONSTANT: SET_ARC_DIRECTION 4102
CONSTANT: SET_BACKGROUND_COLOR 4103
CONSTANT: SET_POLY_MODE 4104
CONSTANT: SET_SCREEN_ANGLE 4105
CONSTANT: SET_SPREAD 4106
CONSTANT: TRANSFORM_CTM 4107
CONSTANT: SET_CLIP_BOX 4108
CONSTANT: SET_BOUNDS 4109
CONSTANT: SET_MIRROR_MODE 4110
CONSTANT: OPENCHANNEL 4110
CONSTANT: DOWNLOADHEADER 4111
CONSTANT: CLOSECHANNEL 4112
CONSTANT: POSTSCRIPT_PASSTHROUGH 4115
CONSTANT: ENCAPSULATED_POSTSCRIPT 4116
CONSTANT: QDI_SETDIBITS 1
CONSTANT: QDI_GETDIBITS 2
CONSTANT: QDI_DIBTOSCREEN 4
CONSTANT: QDI_STRETCHDIB 8
CONSTANT: SP_NOTREPORTED 0x4000
CONSTANT: PR_JOBSTATUS 0
CONSTANT: ASPECT_FILTERING 1
CONSTANT: BS_SOLID 0
CONSTANT: BS_NULL 1
CONSTANT: BS_HOLLOW 1
CONSTANT: BS_HATCHED 2
CONSTANT: BS_PATTERN 3
CONSTANT: BS_INDEXED 4
CONSTANT: BS_DIBPATTERN 5
CONSTANT: BS_DIBPATTERNPT 6
CONSTANT: BS_PATTERN8X8 7
CONSTANT: BS_DIBPATTERN8X8 8
CONSTANT: LCS_CALIBRATED_RGB 0
CONSTANT: LCS_DEVICE_RGB 1
CONSTANT: LCS_DEVICE_CMYK 2
CONSTANT: LCS_GM_BUSINESS 1
CONSTANT: LCS_GM_GRAPHICS 2
CONSTANT: LCS_GM_IMAGES 4
CONSTANT: RASTER_FONTTYPE 1
CONSTANT: DEVICE_FONTTYPE 2
CONSTANT: TRUETYPE_FONTTYPE 4
CONSTANT: DMORIENT_PORTRAIT 1
CONSTANT: DMORIENT_LANDSCAPE 2
CONSTANT: DMPAPER_FIRST 1
CONSTANT: DMPAPER_LETTER 1
CONSTANT: DMPAPER_LETTERSMALL 2
CONSTANT: DMPAPER_TABLOID 3
CONSTANT: DMPAPER_LEDGER 4
CONSTANT: DMPAPER_LEGAL 5
CONSTANT: DMPAPER_STATEMENT 6
CONSTANT: DMPAPER_EXECUTIVE 7
CONSTANT: DMPAPER_A3 8
CONSTANT: DMPAPER_A4 9
CONSTANT: DMPAPER_A4SMALL 10
CONSTANT: DMPAPER_A5 11
CONSTANT: DMPAPER_B4 12
CONSTANT: DMPAPER_B5 13
CONSTANT: DMPAPER_FOLIO 14
CONSTANT: DMPAPER_QUARTO 15
CONSTANT: DMPAPER_10X14 16
CONSTANT: DMPAPER_11X17 17
CONSTANT: DMPAPER_NOTE 18
CONSTANT: DMPAPER_ENV_9 19
CONSTANT: DMPAPER_ENV_10 20
CONSTANT: DMPAPER_ENV_11 21
CONSTANT: DMPAPER_ENV_12 22
CONSTANT: DMPAPER_ENV_14 23
CONSTANT: DMPAPER_CSHEET 24
CONSTANT: DMPAPER_DSHEET 25
CONSTANT: DMPAPER_ESHEET 26
CONSTANT: DMPAPER_ENV_DL 27
CONSTANT: DMPAPER_ENV_C5 28
CONSTANT: DMPAPER_ENV_C3 29
CONSTANT: DMPAPER_ENV_C4 30
CONSTANT: DMPAPER_ENV_C6 31
CONSTANT: DMPAPER_ENV_C65 32
CONSTANT: DMPAPER_ENV_B4 33
CONSTANT: DMPAPER_ENV_B5 34
CONSTANT: DMPAPER_ENV_B6 35
CONSTANT: DMPAPER_ENV_ITALY 36
CONSTANT: DMPAPER_ENV_MONARCH 37
CONSTANT: DMPAPER_ENV_PERSONAL 38
CONSTANT: DMPAPER_FANFOLD_US 39
CONSTANT: DMPAPER_FANFOLD_STD_GERMAN 40
CONSTANT: DMPAPER_FANFOLD_LGL_GERMAN 41
CONSTANT: DMPAPER_ISO_B4 42
CONSTANT: DMPAPER_JAPANESE_POSTCARD 43
CONSTANT: DMPAPER_9X11 44
CONSTANT: DMPAPER_10X11 45
CONSTANT: DMPAPER_15X11 46
CONSTANT: DMPAPER_ENV_INVITE 47
CONSTANT: DMPAPER_RESERVED_48 48
CONSTANT: DMPAPER_RESERVED_49 49
CONSTANT: DMPAPER_LETTER_EXTRA 50
CONSTANT: DMPAPER_LEGAL_EXTRA 51
CONSTANT: DMPAPER_TABLOID_EXTRA 52
CONSTANT: DMPAPER_A4_EXTRA 53
CONSTANT: DMPAPER_LETTER_TRANSVERSE 54
CONSTANT: DMPAPER_A4_TRANSVERSE 55
CONSTANT: DMPAPER_LETTER_EXTRA_TRANSVERSE 56
CONSTANT: DMPAPER_A_PLUS 57
CONSTANT: DMPAPER_B_PLUS 58
CONSTANT: DMPAPER_LETTER_PLUS 59
CONSTANT: DMPAPER_A4_PLUS 60
CONSTANT: DMPAPER_A5_TRANSVERSE 61
CONSTANT: DMPAPER_B5_TRANSVERSE 62
CONSTANT: DMPAPER_A3_EXTRA 63
CONSTANT: DMPAPER_A5_EXTRA 64
CONSTANT: DMPAPER_B5_EXTRA 65
CONSTANT: DMPAPER_A2 66
CONSTANT: DMPAPER_A3_TRANSVERSE 67
CONSTANT: DMPAPER_A3_EXTRA_TRANSVERSE 68
CONSTANT: DMPAPER_DBL_JAPANESE_POSTCARD 69
CONSTANT: DMPAPER_A6 70
CONSTANT: DMPAPER_JENV_KAKU2 71
CONSTANT: DMPAPER_JENV_KAKU3 72
CONSTANT: DMPAPER_JENV_CHOU3 73
CONSTANT: DMPAPER_JENV_CHOU4 74
CONSTANT: DMPAPER_LETTER_ROTATED 75
CONSTANT: DMPAPER_A3_ROTATED 76
CONSTANT: DMPAPER_A4_ROTATED 77
CONSTANT: DMPAPER_A5_ROTATED 78
CONSTANT: DMPAPER_B4_JIS_ROTATED 79
CONSTANT: DMPAPER_B5_JIS_ROTATED 80
CONSTANT: DMPAPER_JAPANESE_POSTCARD_ROTATED 81
CONSTANT: DMPAPER_DBL_JAPANESE_POSTCARD_ROTATED 82
CONSTANT: DMPAPER_A6_ROTATED 83
CONSTANT: DMPAPER_JENV_KAKU2_ROTATED 84
CONSTANT: DMPAPER_JENV_KAKU3_ROTATED 85
CONSTANT: DMPAPER_JENV_CHOU3_ROTATED 86
CONSTANT: DMPAPER_JENV_CHOU4_ROTATED 87
CONSTANT: DMPAPER_B6_JIS 88
CONSTANT: DMPAPER_B6_JIS_ROTATED 89
CONSTANT: DMPAPER_12X11 90
CONSTANT: DMPAPER_JENV_YOU4 91
CONSTANT: DMPAPER_JENV_YOU4_ROTATED 92
CONSTANT: DMPAPER_P16K 93
CONSTANT: DMPAPER_P32K 94
CONSTANT: DMPAPER_P32KBIG 95
CONSTANT: DMPAPER_PENV_1 96
CONSTANT: DMPAPER_PENV_2 97
CONSTANT: DMPAPER_PENV_3 98
CONSTANT: DMPAPER_PENV_4 99
CONSTANT: DMPAPER_PENV_5 100
CONSTANT: DMPAPER_PENV_6 101
CONSTANT: DMPAPER_PENV_7 102
CONSTANT: DMPAPER_PENV_8 103
CONSTANT: DMPAPER_PENV_9 104
CONSTANT: DMPAPER_PENV_10 105
CONSTANT: DMPAPER_P16K_ROTATED 106
CONSTANT: DMPAPER_P32K_ROTATED 107
CONSTANT: DMPAPER_P32KBIG_ROTATED 108
CONSTANT: DMPAPER_PENV_1_ROTATED 109
CONSTANT: DMPAPER_PENV_2_ROTATED 110
CONSTANT: DMPAPER_PENV_3_ROTATED 111
CONSTANT: DMPAPER_PENV_4_ROTATED 112
CONSTANT: DMPAPER_PENV_5_ROTATED 113
CONSTANT: DMPAPER_PENV_6_ROTATED 114
CONSTANT: DMPAPER_PENV_7_ROTATED 115
CONSTANT: DMPAPER_PENV_8_ROTATED 116
CONSTANT: DMPAPER_PENV_9_ROTATED 117
CONSTANT: DMPAPER_PENV_10_ROTATED 118
CONSTANT: DMPAPER_LAST 118
CONSTANT: DMPAPER_USER 256
CONSTANT: DMBIN_FIRST 1
CONSTANT: DMBIN_UPPER 1
CONSTANT: DMBIN_ONLYONE 1
CONSTANT: DMBIN_LOWER 2
CONSTANT: DMBIN_MIDDLE 3
CONSTANT: DMBIN_MANUAL 4
CONSTANT: DMBIN_ENVELOPE 5
CONSTANT: DMBIN_ENVMANUAL 6
CONSTANT: DMBIN_AUTO 7
CONSTANT: DMBIN_TRACTOR 8
CONSTANT: DMBIN_SMALLFMT 9
CONSTANT: DMBIN_LARGEFMT 10
CONSTANT: DMBIN_LARGECAPACITY 11
CONSTANT: DMBIN_CASSETTE 14
CONSTANT: DMBIN_FORMSOURCE 15
CONSTANT: DMBIN_LAST 15
CONSTANT: DMBIN_USER 256
CONSTANT: DMRES_DRAFT -1
CONSTANT: DMRES_LOW -2
CONSTANT: DMRES_MEDIUM -3
CONSTANT: DMRES_HIGH -4
CONSTANT: DMCOLOR_MONOCHROME 1
CONSTANT: DMCOLOR_COLOR 2
CONSTANT: DMDUP_SIMPLEX 1
CONSTANT: DMDUP_VERTICAL 2
CONSTANT: DMDUP_HORIZONTAL 3
CONSTANT: DMTT_BITMAP 1
CONSTANT: DMTT_DOWNLOAD 2
CONSTANT: DMTT_SUBDEV 3
CONSTANT: DMTT_DOWNLOAD_OUTLINE 4
CONSTANT: DMCOLLATE_FALSE 0
CONSTANT: DMCOLLATE_TRUE 1
CONSTANT: DM_SPECVERSION 800
CONSTANT: DM_GRAYSCALE 1
CONSTANT: DM_INTERLACED 2
CONSTANT: DM_UPDATE 1
CONSTANT: DM_COPY 2
CONSTANT: DM_PROMPT 4
CONSTANT: DM_MODIFY 8
ALIAS: DM_IN_BUFFER DM_MODIFY
ALIAS: DM_IN_PROMPT DM_PROMPT
ALIAS: DM_OUT_BUFFER DM_COPY
ALIAS: DM_OUT_DEFAULT DM_UPDATE
CONSTANT: DM_ORIENTATION 0x00000001
CONSTANT: DM_PAPERSIZE 0x00000002
CONSTANT: DM_PAPERLENGTH 0x00000004
CONSTANT: DM_PAPERWIDTH 0x00000008
CONSTANT: DM_SCALE 0x00000010
CONSTANT: DM_POSITION 0x00000020
CONSTANT: DM_COPIES 0x00000100
CONSTANT: DM_DEFAULTSOURCE 0x00000200
CONSTANT: DM_PRINTQUALITY 0x00000400
CONSTANT: DM_COLOR 0x00000800
CONSTANT: DM_DUPLEX 0x00001000
CONSTANT: DM_YRESOLUTION 0x00002000
CONSTANT: DM_TTOPTION 0x00004000
CONSTANT: DM_COLLATE 0x00008000
CONSTANT: DM_FORMNAME 0x00010000
CONSTANT: DM_LOGPIXELS 0x00020000
CONSTANT: DM_BITSPERPEL 0x00040000
CONSTANT: DM_PELSWIDTH 0x00080000
CONSTANT: DM_PELSHEIGHT 0x00100000
CONSTANT: DM_DISPLAYFLAGS 0x00200000
CONSTANT: DM_DISPLAYFREQUENCY 0x00400000
CONSTANT: DM_ICMMETHOD 0x00800000
CONSTANT: DM_ICMINTENT 0x01000000
CONSTANT: DM_MEDIATYPE 0x02000000
CONSTANT: DM_DITHERTYPE 0x04000000
CONSTANT: DM_PANNINGWIDTH 0x08000000
CONSTANT: DM_PANNINGHEIGHT 0x10000000
CONSTANT: DM_DISPLAYFIXEDOUTPUT 0x20000000
CONSTANT: DM_DISPLAYORIENTATION 0x00000080
CONSTANT: DMDO_DEFAULT 0x00000000
CONSTANT: DMDO_90 0x00000001
CONSTANT: DMDO_180 0x00000002
CONSTANT: DMDO_270 0x00000003
CONSTANT: DMDFO_DEFAULT 0x00000000
CONSTANT: DMDFO_STRETCH 0x00000001
CONSTANT: DMDFO_CENTER 0x00000002
CONSTANT: DMICMMETHOD_NONE 1
CONSTANT: DMICMMETHOD_SYSTEM 2
CONSTANT: DMICMMETHOD_DRIVER 3
CONSTANT: DMICMMETHOD_DEVICE 4
CONSTANT: DMICMMETHOD_USER 256
CONSTANT: DMICM_SATURATE 1
CONSTANT: DMICM_CONTRAST 2
CONSTANT: DMICM_COLORMETRIC 3
CONSTANT: DMICM_USER 256
CONSTANT: DMMEDIA_STANDARD 1
CONSTANT: DMMEDIA_TRANSPARENCY 2
CONSTANT: DMMEDIA_GLOSSY 3
CONSTANT: DMMEDIA_USER 256
CONSTANT: DMDITHER_NONE 1
CONSTANT: DMDITHER_COARSE 2
CONSTANT: DMDITHER_FINE 3
CONSTANT: DMDITHER_LINEART 4
CONSTANT: DMDITHER_ERRORDIFFUSION 5
CONSTANT: DMDITHER_RESERVED6 6
CONSTANT: DMDITHER_RESERVED7 7
CONSTANT: DMDITHER_RESERVED8 8
CONSTANT: DMDITHER_RESERVED9 9
CONSTANT: DMDITHER_GRAYSCALE 10
CONSTANT: DMDITHER_USER 256
CONSTANT: GDI_ERROR 0xFFFFFFFF
: HGDI_ERROR ( -- alien ) GDI_ERROR <alien> ; inline
CONSTANT: TMPF_FIXED_PITCH 1
CONSTANT: TMPF_VECTOR 2
CONSTANT: TMPF_TRUETYPE 4
CONSTANT: TMPF_DEVICE 8
CONSTANT: NTM_ITALIC 1
CONSTANT: NTM_BOLD 32
CONSTANT: NTM_REGULAR 64
CONSTANT: TT_POLYGON_TYPE 24
CONSTANT: TT_PRIM_LINE 1
CONSTANT: TT_PRIM_QSPLINE 2
CONSTANT: TT_PRIM_CSPLINE 3 
CONSTANT: FONTMAPPER_MAX 10
CONSTANT: ENHMETA_STOCK_OBJECT 0x80000000
CONSTANT: WGL_FONT_LINES 0
CONSTANT: WGL_FONT_POLYGONS 1
CONSTANT: LPD_DOUBLEBUFFER 1
CONSTANT: LPD_STEREO 2
CONSTANT: LPD_SUPPORT_GDI 16
CONSTANT: LPD_SUPPORT_OPENGL 32
CONSTANT: LPD_SHARE_DEPTH 64
CONSTANT: LPD_SHARE_STENCIL 128
CONSTANT: LPD_SHARE_ACCUM 256
CONSTANT: LPD_SWAP_EXCHANGE 512
CONSTANT: LPD_SWAP_COPY 1024
CONSTANT: LPD_TRANSPARENT 4096
CONSTANT: LPD_TYPE_RGBA 0
CONSTANT: LPD_TYPE_COLORINDEX 1
CONSTANT: WGL_SWAP_MAIN_PLANE 1
CONSTANT: WGL_SWAP_OVERLAY1 2
CONSTANT: WGL_SWAP_OVERLAY2 4
CONSTANT: WGL_SWAP_OVERLAY3 8
CONSTANT: WGL_SWAP_OVERLAY4 16
CONSTANT: WGL_SWAP_OVERLAY5 32
CONSTANT: WGL_SWAP_OVERLAY6 64
CONSTANT: WGL_SWAP_OVERLAY7 128
CONSTANT: WGL_SWAP_OVERLAY8 256
CONSTANT: WGL_SWAP_OVERLAY9 512
CONSTANT: WGL_SWAP_OVERLAY10 1024
CONSTANT: WGL_SWAP_OVERLAY11 2048
CONSTANT: WGL_SWAP_OVERLAY12 4096
CONSTANT: WGL_SWAP_OVERLAY13 8192
CONSTANT: WGL_SWAP_OVERLAY14 16384
CONSTANT: WGL_SWAP_OVERLAY15 32768
CONSTANT: WGL_SWAP_UNDERLAY1 65536
CONSTANT: WGL_SWAP_UNDERLAY2 0x20000
CONSTANT: WGL_SWAP_UNDERLAY3 0x40000
CONSTANT: WGL_SWAP_UNDERLAY4 0x80000
CONSTANT: WGL_SWAP_UNDERLAY5 0x100000
CONSTANT: WGL_SWAP_UNDERLAY6 0x200000
CONSTANT: WGL_SWAP_UNDERLAY7 0x400000
CONSTANT: WGL_SWAP_UNDERLAY8 0x800000
CONSTANT: WGL_SWAP_UNDERLAY9 0x1000000
CONSTANT: WGL_SWAP_UNDERLAY10 0x2000000
CONSTANT: WGL_SWAP_UNDERLAY11 0x4000000
CONSTANT: WGL_SWAP_UNDERLAY12 0x8000000
CONSTANT: WGL_SWAP_UNDERLAY13 0x10000000
CONSTANT: WGL_SWAP_UNDERLAY14 0x20000000
CONSTANT: WGL_SWAP_UNDERLAY15 0x40000000
CONSTANT: AC_SRC_OVER 0x00
CONSTANT: AC_SRC_ALPHA 0x01
CONSTANT: AC_SRC_NO_PREMULT_ALPHA 0x01
CONSTANT: AC_SRC_NO_ALPHA 0x02
CONSTANT: AC_DST_NO_PREMULT_ALPHA 0x10
CONSTANT: AC_DST_NO_ALPHA 0x20
CONSTANT: LAYOUT_RTL 1
CONSTANT: LAYOUT_BITMAPORIENTATIONPRESERVED 8
CONSTANT: CS_ENABLE 0x00000001
CONSTANT: CS_DISABLE 0x00000002
CONSTANT: CS_DELETE_TRANSFORM 0x00000003
CONSTANT: GRADIENT_FILL_RECT_H 0x00
CONSTANT: GRADIENT_FILL_RECT_V 0x01
CONSTANT: GRADIENT_FILL_TRIANGLE 0x02
CONSTANT: GRADIENT_FILL_OP_FLAG 0xff
CONSTANT: COLORMATCHTOTARGET_EMBEDED 0x00000001
CONSTANT: CREATECOLORSPACE_EMBEDED 0x00000001
CONSTANT: SETICMPROFILE_EMBEDED 0x00000001

CONSTANT: DISPLAY_DEVICE_ATTACHED_TO_DESKTOP 0x00000001
CONSTANT: DISPLAY_DEVICE_MULTI_DRIVER 0x00000002
CONSTANT: DISPLAY_DEVICE_PRIMARY_DEVICE 0x00000004
CONSTANT: DISPLAY_DEVICE_MIRRORING_DRIVER 0x00000008
CONSTANT: DISPLAY_DEVICE_VGA_COMPATIBLE 0x00000010
CONSTANT: DISPLAY_DEVICE_REMOVABLE 0x00000020
CONSTANT: DISPLAY_DEVICE_MODESPRUNED 0x08000000

CONSTANT: NTM_NONNEGATIVE_AC 0x00010000
CONSTANT: NTM_PS_OPENTYPE 0x00020000
CONSTANT: NTM_TT_OPENTYPE 0x00040000
CONSTANT: NTM_MULTIPLEMASTER 0x00080000
CONSTANT: NTM_TYPE1 0x00100000
CONSTANT: NTM_DSIG 0x00200000

CONSTANT: GGI_MARK_NONEXISTING_GLYPHS 1

LIBRARY: gdi32

! FUNCTION: AbortDoc
! FUNCTION: AbortPath
! FUNCTION: AddFontMemResourceEx
! FUNCTION: AddFontResourceA
! FUNCTION: AddFontResourceExA
! FUNCTION: AddFontResourceExW
! FUNCTION: AddFontResourceTracking
! FUNCTION: AddFontResourceW
! FUNCTION: AngleArc
! FUNCTION: AnimatePalette
! FUNCTION: AnyLinkedFonts
! FUNCTION: Arc
! FUNCTION: ArcTo
! FUNCTION: BeginPath
! FUNCTION: bInitSystemAndFontsDirectoriesW
! FUNCTION: BitBlt
! FUNCTION: bMakePathNameW
! FUNCTION: BRUSHOBJ_hGetColorTransform
! FUNCTION: BRUSHOBJ_pvAllocRbrush
! FUNCTION: BRUSHOBJ_pvGetRbrush
! FUNCTION: BRUSHOBJ_ulGetBrushColor
! FUNCTION: CancelDC
! FUNCTION: cGetTTFFromFOT
! FUNCTION: CheckColorsInGamut
FUNCTION: int ChoosePixelFormat ( HDC hDC, PFD* ppfd ) ;
! FUNCTION: Chord
! FUNCTION: ClearBitmapAttributes
! FUNCTION: ClearBrushAttributes
! FUNCTION: CLIPOBJ_bEnum
! FUNCTION: CLIPOBJ_cEnumStart
! FUNCTION: CLIPOBJ_ppoGetPath
! FUNCTION: CloseEnhMetaFile
! FUNCTION: CloseFigure
! FUNCTION: CloseMetaFile
! FUNCTION: ColorCorrectPalette
! FUNCTION: ColorMatchToTarget
! FUNCTION: CombineRgn
! FUNCTION: CombineTransform
! FUNCTION: CopyEnhMetaFileA
! FUNCTION: CopyEnhMetaFileW
! FUNCTION: CopyMetaFileA
! FUNCTION: CopyMetaFileW
! FUNCTION: CreateBitmap
! FUNCTION: CreateBitmapIndirect
! FUNCTION: CreateBrushIndirect
! FUNCTION: CreateColorSpaceA
! FUNCTION: CreateColorSpaceW
! FUNCTION: CreateCompatibleBitmap
FUNCTION: HDC CreateCompatibleDC ( HDC hdc ) ;
! FUNCTION: CreateDCA
! FUNCTION: CreateDCW
! FUNCTION: CreateDIBitmap
! FUNCTION: CreateDIBPatternBrush
! FUNCTION: CreateDIBPatternBrushPt
FUNCTION: HBITMAP CreateDIBSection ( HDC hdc, BITMAPINFO* pbmi, UINT iUsage, void** ppvBits, HANDLE hSection, DWORD dwOffset ) ;
! FUNCTION: CreateDiscardableBitmap
! FUNCTION: CreateEllipticRgn
! FUNCTION: CreateEllipticRgnIndirect
! FUNCTION: CreateEnhMetaFileA
! FUNCTION: CreateEnhMetaFileW
! FUNCTION: CreateFontA
! FUNCTION: CreateFontIndirectA
! FUNCTION: CreateFontIndirectExA
! FUNCTION: CreateFontIndirectExW
! FUNCTION: CreateFontIndirectW
FUNCTION: HFONT CreateFontW ( int nHeight, int nWidth, int nEscapement, int nOrientation, int fnWeight, DWORD fdwItalic, DWORD fdwUnderline, DWORD fdwStrikeOut, DWORD fdwCharSet, DWORD fdwOutputPrecision, DWORD fdwClipPrecision, DWORD fdwQuality, DWORD fdwPitchAndFamily, LPCTSTR lpszFace ) ;
ALIAS: CreateFont CreateFontW
! FUNCTION: CreateHalftonePalette
! FUNCTION: CreateHatchBrush
! FUNCTION: CreateICA
! FUNCTION: CreateICW
! FUNCTION: CreateMetaFileA
! FUNCTION: CreateMetaFileW
! FUNCTION: CreatePalette
! FUNCTION: CreatePatternBrush
! FUNCTION: CreatePen
! FUNCTION: CreatePenIndirect
! FUNCTION: CreatePolygonRgn
! FUNCTION: CreatePolyPolygonRgn
FUNCTION: HRGN CreateRectRgn ( int x, int y, int w, int h ) ;
! FUNCTION: CreateRectRgnIndirect
! FUNCTION: CreateRoundRectRgn
! FUNCTION: CreateScalableFontResourceA
! FUNCTION: CreateScalableFontResourceW
FUNCTION: HBRUSH CreateSolidBrush ( COLORREF colorref ) ;
! FUNCTION: DdEntry0
! FUNCTION: DdEntry1
! FUNCTION: DdEntry10
! FUNCTION: DdEntry11
! FUNCTION: DdEntry12
! FUNCTION: DdEntry13
! FUNCTION: DdEntry14
! FUNCTION: DdEntry15
! FUNCTION: DdEntry16
! FUNCTION: DdEntry17
! FUNCTION: DdEntry18
! FUNCTION: DdEntry19
! FUNCTION: DdEntry2
! FUNCTION: DdEntry20
! FUNCTION: DdEntry21
! FUNCTION: DdEntry22
! FUNCTION: DdEntry23
! FUNCTION: DdEntry24
! FUNCTION: DdEntry25
! FUNCTION: DdEntry26
! FUNCTION: DdEntry27
! FUNCTION: DdEntry28
! FUNCTION: DdEntry29
! FUNCTION: DdEntry3
! FUNCTION: DdEntry30
! FUNCTION: DdEntry31
! FUNCTION: DdEntry32
! FUNCTION: DdEntry33
! FUNCTION: DdEntry34
! FUNCTION: DdEntry35
! FUNCTION: DdEntry36
! FUNCTION: DdEntry37
! FUNCTION: DdEntry38
! FUNCTION: DdEntry39
! FUNCTION: DdEntry4
! FUNCTION: DdEntry40
! FUNCTION: DdEntry41
! FUNCTION: DdEntry42
! FUNCTION: DdEntry43
! FUNCTION: DdEntry44
! FUNCTION: DdEntry45
! FUNCTION: DdEntry46
! FUNCTION: DdEntry47
! FUNCTION: DdEntry48
! FUNCTION: DdEntry49
! FUNCTION: DdEntry5
! FUNCTION: DdEntry50
! FUNCTION: DdEntry51
! FUNCTION: DdEntry52
! FUNCTION: DdEntry53
! FUNCTION: DdEntry54
! FUNCTION: DdEntry55
! FUNCTION: DdEntry56
! FUNCTION: DdEntry6
! FUNCTION: DdEntry7
! FUNCTION: DdEntry8
! FUNCTION: DdEntry9
! FUNCTION: DeleteColorSpace
FUNCTION: BOOL DeleteDC ( HDC hdc ) ;
DESTRUCTOR: DeleteDC
! FUNCTION: DeleteEnhMetaFile
! FUNCTION: DeleteMetaFile
FUNCTION: BOOL DeleteObject ( HGDIOBJ hObject ) ;
DESTRUCTOR: DeleteObject
FUNCTION: int DescribePixelFormat ( HDC hdc, int iPixelFormat, UINT nBytes, PIXELFORMATDESCRIPTOR* ppfd ) ;
! FUNCTION: DeviceCapabilitiesExA
! FUNCTION: DeviceCapabilitiesExW
! FUNCTION: DPtoLP
! FUNCTION: DrawEscape
! FUNCTION: Ellipse
! FUNCTION: EnableEUDC
! FUNCTION: EndDoc
! FUNCTION: EndFormPage
! FUNCTION: EndPage
! FUNCTION: EndPath
! FUNCTION: EngAcquireSemaphore
! FUNCTION: EngAlphaBlend
! FUNCTION: EngAssociateSurface
! FUNCTION: EngBitBlt
! FUNCTION: EngCheckAbort
! FUNCTION: EngComputeGlyphSet
! FUNCTION: EngCopyBits
! FUNCTION: EngCreateBitmap
! FUNCTION: EngCreateClip
! FUNCTION: EngCreateDeviceBitmap
! FUNCTION: EngCreateDeviceSurface
! FUNCTION: EngCreatePalette
! FUNCTION: EngCreateSemaphore
! FUNCTION: EngDeleteClip
! FUNCTION: EngDeletePalette
! FUNCTION: EngDeletePath
! FUNCTION: EngDeleteSemaphore
! FUNCTION: EngDeleteSurface
! FUNCTION: EngEraseSurface
! FUNCTION: EngFillPath
! FUNCTION: EngFindResource
! FUNCTION: EngFreeModule
! FUNCTION: EngGetCurrentCodePage
! FUNCTION: EngGetDriverName
! FUNCTION: EngGetPrinterDataFileName
! FUNCTION: EngGradientFill
! FUNCTION: EngLineTo
! FUNCTION: EngLoadModule
! FUNCTION: EngLockSurface
! FUNCTION: EngMarkBandingSurface
! FUNCTION: EngMultiByteToUnicodeN
! FUNCTION: EngMultiByteToWideChar
! FUNCTION: EngPaint
! FUNCTION: EngPlgBlt
! FUNCTION: EngQueryEMFInfo
! FUNCTION: EngQueryLocalTime
! FUNCTION: EngReleaseSemaphore
! FUNCTION: EngStretchBlt
! FUNCTION: EngStretchBltROP
! FUNCTION: EngStrokeAndFillPath
! FUNCTION: EngStrokePath
! FUNCTION: EngTextOut
! FUNCTION: EngTransparentBlt
! FUNCTION: EngUnicodeToMultiByteN
! FUNCTION: EngUnlockSurface
! FUNCTION: EngWideCharToMultiByte
! FUNCTION: EnumEnhMetaFile
! FUNCTION: EnumFontFamiliesA
! FUNCTION: EnumFontFamiliesExA
! FUNCTION: EnumFontFamiliesExW
! FUNCTION: EnumFontFamiliesW
! FUNCTION: EnumFontsA
! FUNCTION: EnumFontsW
! FUNCTION: EnumICMProfilesA
! FUNCTION: EnumICMProfilesW
! FUNCTION: EnumMetaFile
! FUNCTION: EnumObjects
! FUNCTION: EqualRgn
! FUNCTION: Escape
! FUNCTION: EudcLoadLinkW
! FUNCTION: EudcUnloadLinkW
! FUNCTION: ExcludeClipRect
! FUNCTION: ExtCreatePen
! FUNCTION: ExtCreateRegion
! FUNCTION: ExtEscape
! FUNCTION: ExtFloodFill
! FUNCTION: ExtSelectClipRgn
! FUNCTION: ExtTextOutA
FUNCTION: BOOL ExtTextOutW ( HDC hdc, int X, int Y, UINT fuOptions, RECT* lprc, LPCTSTR lpString, UINT cbCount, INT* lpDx ) ;
ALIAS: ExtTextOut ExtTextOutW
! FUNCTION: FillPath
! FUNCTION: FillRgn
! FUNCTION: FixBrushOrgEx
! FUNCTION: FlattenPath
! FUNCTION: FloodFill
! FUNCTION: FontIsLinked
! FUNCTION: FONTOBJ_cGetAllGlyphHandles
! FUNCTION: FONTOBJ_cGetGlyphs
! FUNCTION: FONTOBJ_pfdg
! FUNCTION: FONTOBJ_pifi
! FUNCTION: FONTOBJ_pQueryGlyphAttrs
! FUNCTION: FONTOBJ_pvTrueTypeFontFile
! FUNCTION: FONTOBJ_pxoGetXform
! FUNCTION: FONTOBJ_vGetInfo
! FUNCTION: FrameRgn
! FUNCTION: GdiAddFontResourceW
! FUNCTION: GdiAddGlsBounds
! FUNCTION: GdiAddGlsRecord
! FUNCTION: GdiAlphaBlend
! FUNCTION: GdiArtificialDecrementDriver
! FUNCTION: GdiCleanCacheDC
! FUNCTION: GdiComment
! FUNCTION: GdiConsoleTextOut
! FUNCTION: GdiConvertAndCheckDC
! FUNCTION: GdiConvertBitmap
! FUNCTION: GdiConvertBitmapV5
! FUNCTION: GdiConvertBrush
! FUNCTION: GdiConvertDC
! FUNCTION: GdiConvertEnhMetaFile
! FUNCTION: GdiConvertFont
! FUNCTION: GdiConvertMetaFilePict
! FUNCTION: GdiConvertPalette
! FUNCTION: GdiConvertRegion
! FUNCTION: GdiConvertToDevmodeW
! FUNCTION: GdiCreateLocalEnhMetaFile
! FUNCTION: GdiCreateLocalMetaFilePict
! FUNCTION: GdiDeleteLocalDC
! FUNCTION: GdiDeleteSpoolFileHandle
! FUNCTION: GdiDescribePixelFormat
! FUNCTION: GdiDllInitialize
! FUNCTION: GdiDrawStream
! FUNCTION: GdiEndDocEMF
! FUNCTION: GdiEndPageEMF
! FUNCTION: GdiEntry1
! FUNCTION: GdiEntry10
! FUNCTION: GdiEntry11
! FUNCTION: GdiEntry12
! FUNCTION: GdiEntry13
! FUNCTION: GdiEntry14
! FUNCTION: GdiEntry15
! FUNCTION: GdiEntry16
! FUNCTION: GdiEntry2
! FUNCTION: GdiEntry3
! FUNCTION: GdiEntry4
! FUNCTION: GdiEntry5
! FUNCTION: GdiEntry6
! FUNCTION: GdiEntry7
! FUNCTION: GdiEntry8
! FUNCTION: GdiEntry9
! FUNCTION: GdiFixUpHandle
FUNCTION: BOOL GdiFlush ( ) ;
! FUNCTION: GdiFullscreenControl
! FUNCTION: GdiGetBatchLimit
! FUNCTION: GdiGetCharDimensions
! FUNCTION: GdiGetCodePage
! FUNCTION: GdiGetDC
! FUNCTION: GdiGetDevmodeForPage
! FUNCTION: GdiGetLocalBrush
! FUNCTION: GdiGetLocalDC
! FUNCTION: GdiGetLocalFont
! FUNCTION: GdiGetPageCount
! FUNCTION: GdiGetPageHandle
! FUNCTION: GdiGetSpoolFileHandle
! FUNCTION: GdiGetSpoolMessage
! FUNCTION: GdiGradientFill
! FUNCTION: GdiInitializeLanguagePack
! FUNCTION: GdiInitSpool
! FUNCTION: GdiIsMetaFileDC
! FUNCTION: GdiIsMetaPrintDC
! FUNCTION: GdiIsPlayMetafileDC
! FUNCTION: GdiPlayDCScript
! FUNCTION: GdiPlayEMF
! FUNCTION: GdiPlayJournal
! FUNCTION: GdiPlayPageEMF
! FUNCTION: GdiPlayPrivatePageEMF
! FUNCTION: GdiPlayScript
! FUNCTION: gdiPlaySpoolStream
! FUNCTION: GdiPrinterThunk
! FUNCTION: GdiProcessSetup
! FUNCTION: GdiQueryFonts
! FUNCTION: GdiQueryTable
! FUNCTION: GdiRealizationInfo
! FUNCTION: GdiReleaseDC
! FUNCTION: GdiReleaseLocalDC
! FUNCTION: GdiResetDCEMF
! FUNCTION: GdiSetAttrs
! FUNCTION: GdiSetBatchLimit
! FUNCTION: GdiSetLastError
! FUNCTION: GdiSetPixelFormat
! FUNCTION: GdiSetServerAttr
! FUNCTION: GdiStartDocEMF
! FUNCTION: GdiStartPageEMF
! FUNCTION: GdiSwapBuffers
! FUNCTION: GdiTransparentBlt
! FUNCTION: GdiValidateHandle
! FUNCTION: GetArcDirection
! FUNCTION: GetAspectRatioFilterEx
! FUNCTION: GetBitmapAttributes
! FUNCTION: GetBitmapBits
! FUNCTION: GetBitmapDimensionEx
! FUNCTION: GetBkColor
! FUNCTION: GetBkMode
! FUNCTION: GetBoundsRect
! FUNCTION: GetBrushAttributes
! FUNCTION: GetBrushOrgEx
! FUNCTION: GetCharABCWidthsA
! FUNCTION: GetCharABCWidthsFloatA
! FUNCTION: GetCharABCWidthsFloatW
! FUNCTION: GetCharABCWidthsI
! FUNCTION: GetCharABCWidthsW
! FUNCTION: GetCharacterPlacementA
! FUNCTION: GetCharacterPlacementW
! FUNCTION: GetCharWidth32A
! FUNCTION: GetCharWidth32W
! FUNCTION: GetCharWidthA
! FUNCTION: GetCharWidthFloatA
! FUNCTION: GetCharWidthFloatW
! FUNCTION: GetCharWidthI
! FUNCTION: GetCharWidthInfo
! FUNCTION: GetCharWidthW
! FUNCTION: GetClipBox
! FUNCTION: GetClipRgn
! FUNCTION: GetColorAdjustment
! FUNCTION: GetColorSpace
! FUNCTION: GetCurrentObject
! FUNCTION: GetCurrentPositionEx
! FUNCTION: GetDCBrushColor
! FUNCTION: GetDCOrgEx
! FUNCTION: GetDCPenColor
! FUNCTION: GetDeviceCaps
! FUNCTION: GetDeviceGammaRamp
! FUNCTION: GetDIBColorTable
! FUNCTION: GetDIBits
! FUNCTION: GetEnhMetaFileA
! FUNCTION: GetEnhMetaFileBits
! FUNCTION: GetEnhMetaFileDescriptionA
! FUNCTION: GetEnhMetaFileDescriptionW
! FUNCTION: GetEnhMetaFileHeader
! FUNCTION: GetEnhMetaFilePaletteEntries
! FUNCTION: GetEnhMetaFilePixelFormat
! FUNCTION: GetEnhMetaFileW
! FUNCTION: GetETM
! FUNCTION: GetEUDCTimeStamp
! FUNCTION: GetEUDCTimeStampExW
! FUNCTION: GetFontAssocStatus
! FUNCTION: GetFontData
! FUNCTION: GetFontLanguageInfo
! FUNCTION: GetFontResourceInfoW
! FUNCTION: GetFontUnicodeRanges
! FUNCTION: GetGlyphIndicesA
! FUNCTION: GetGlyphIndicesW
! FUNCTION: GetGlyphOutline
! FUNCTION: GetGlyphOutlineA
! FUNCTION: GetGlyphOutlineW
! FUNCTION: GetGlyphOutlineWow
! FUNCTION: GetGraphicsMode
! FUNCTION: GetHFONT
! FUNCTION: GetICMProfileA
! FUNCTION: GetICMProfileW
! FUNCTION: GetKerningPairs
! FUNCTION: GetKerningPairsA
! FUNCTION: GetKerningPairsW
! FUNCTION: GetLayout
! FUNCTION: GetLogColorSpaceA
! FUNCTION: GetLogColorSpaceW
! FUNCTION: GetMapMode
! FUNCTION: GetMetaFileA
! FUNCTION: GetMetaFileBitsEx
! FUNCTION: GetMetaFileW
! FUNCTION: GetMetaRgn
! FUNCTION: GetMiterLimit
! FUNCTION: GetNearestColor
! FUNCTION: GetNearestPaletteIndex
! FUNCTION: GetObjectA
! FUNCTION: GetObjectType
! FUNCTION: GetObjectW
! FUNCTION: GetOutlineTextMetricsA
! FUNCTION: GetOutlineTextMetricsW
! FUNCTION: GetPaletteEntries
! FUNCTION: GetPath
! FUNCTION: GetPixel
! FUNCTION: GetPixelFormat
! FUNCTION: GetPolyFillMode
! FUNCTION: GetRandomRgn
! FUNCTION: GetRasterizerCaps
! FUNCTION: GetRegionData
! FUNCTION: GetRelAbs
! FUNCTION: GetRgnBox
! FUNCTION: GetROP2
FUNCTION: HGDIOBJ GetStockObject ( int fnObject ) ;
! FUNCTION: GetStretchBltMode
! FUNCTION: GetStringBitmapA
! FUNCTION: GetStringBitmapW
! FUNCTION: GetSystemPaletteEntries
! FUNCTION: GetSystemPaletteUse
! FUNCTION: GetTextAlign
! FUNCTION: GetTextCharacterExtra
! FUNCTION: GetTextCharset
! FUNCTION: GetTextCharsetInfo
! FUNCTION: GetTextColor
! FUNCTION: GetTextExtentExPointA
! FUNCTION: GetTextExtentExPointI
! FUNCTION: GetTextExtentExPointW
! FUNCTION: GetTextExtentExPointWPri
! FUNCTION: GetTextExtentPoint32A
! FUNCTION: GetTextExtentPoint32W
! FUNCTION: GetTextExtentPointA
! FUNCTION: GetTextExtentPointI
! FUNCTION: GetTextExtentPointW
! FUNCTION: GetTextFaceA
! FUNCTION: GetTextFaceAliasW
! FUNCTION: GetTextFaceW
! FUNCTION: GetTextMetricsA
FUNCTION: BOOL GetTextMetricsW ( HDC hdc, LPTEXTMETRIC lptm ) ;
ALIAS: GetTextMetrics GetTextMetricsW
! FUNCTION: GetTransform
! FUNCTION: GetViewportExtEx
! FUNCTION: GetViewportOrgEx
! FUNCTION: GetWindowExtEx
! FUNCTION: GetWindowOrgEx
! FUNCTION: GetWinMetaFileBits
! FUNCTION: GetWorldTransform
! FUNCTION: HT_Get8BPPFormatPalette
! FUNCTION: HT_Get8BPPMaskPalette
! FUNCTION: IntersectClipRect
! FUNCTION: InvertRgn
! FUNCTION: IsValidEnhMetaRecord
! FUNCTION: IsValidEnhMetaRecordOffExt
! FUNCTION: LineDDA
! FUNCTION: LineTo
! FUNCTION: LPtoDP
! FUNCTION: MaskBlt
! FUNCTION: MirrorRgn
! FUNCTION: ModifyWorldTransform
! FUNCTION: MoveToEx
! FUNCTION: NamedEscape
! FUNCTION: OffsetClipRgn
! FUNCTION: OffsetRgn
! FUNCTION: OffsetViewportOrgEx
! FUNCTION: OffsetWindowOrgEx
! FUNCTION: PaintRgn
! FUNCTION: PatBlt
! FUNCTION: PATHOBJ_bEnum
! FUNCTION: PATHOBJ_bEnumClipLines
! FUNCTION: PATHOBJ_vEnumStart
! FUNCTION: PATHOBJ_vEnumStartClipLines
! FUNCTION: PATHOBJ_vGetBounds
! FUNCTION: PathToRegion
! FUNCTION: Pie
! FUNCTION: PlayEnhMetaFile
! FUNCTION: PlayEnhMetaFileRecord
! FUNCTION: PlayMetaFile
! FUNCTION: PlayMetaFileRecord
! FUNCTION: PlgBlt
! FUNCTION: PolyBezier
! FUNCTION: PolyBezierTo
! FUNCTION: PolyDraw
! FUNCTION: Polygon
! FUNCTION: Polyline
! FUNCTION: PolylineTo
! FUNCTION: PolyPatBlt
! FUNCTION: PolyPolygon
! FUNCTION: PolyPolyline
! FUNCTION: PolyTextOutA
! FUNCTION: PolyTextOutW
! FUNCTION: PtInRegion
! FUNCTION: PtVisible
! FUNCTION: QueryFontAssocStatus
! FUNCTION: RealizePalette
FUNCTION: BOOL Rectangle ( HDC hdc, int x, int y, int w, int h ) ;
! FUNCTION: RectInRegion
! FUNCTION: RectVisible
! FUNCTION: RemoveFontMemResourceEx
! FUNCTION: RemoveFontResourceA
! FUNCTION: RemoveFontResourceExA
! FUNCTION: RemoveFontResourceExW
! FUNCTION: RemoveFontResourceTracking
! FUNCTION: RemoveFontResourceW
! FUNCTION: ResetDCA
! FUNCTION: ResetDCW
! FUNCTION: ResizePalette
! FUNCTION: RestoreDC
! FUNCTION: RoundRect
! FUNCTION: SaveDC
! FUNCTION: ScaleViewportExtEx
! FUNCTION: ScaleWindowExtEx
! FUNCTION: SelectBrushLocal
! FUNCTION: SelectClipPath
FUNCTION: int SelectClipRgn ( HDC hDC, HRGN hrgn ) ;
! FUNCTION: SelectFontLocal
FUNCTION: HGDIOBJ SelectObject ( HDC hdc, HGDIOBJ hgdiobj ) ;
! FUNCTION: SelectPalette
! FUNCTION: SetAbortProc
! FUNCTION: SetArcDirection
! FUNCTION: SetBitmapAttributes
! FUNCTION: SetBitmapBits
! FUNCTION: SetBitmapDimensionEx
FUNCTION: COLORREF SetBkColor ( HDC hdc, COLORREF color ) ;
! FUNCTION: SetBkMode
! FUNCTION: SetBoundsRect
! FUNCTION: SetBrushAttributes
! FUNCTION: SetBrushOrgEx
! FUNCTION: SetColorAdjustment
! FUNCTION: SetColorSpace
FUNCTION: COLORREF SetDCBrushColor ( HDC hdc, COLORREF color ) ;
FUNCTION: COLORREF SetDCPenColor ( HDC hdc, COLORREF color ) ;
! FUNCTION: SetDeviceGammaRamp
! FUNCTION: SetDIBColorTable
! FUNCTION: SetDIBits
! FUNCTION: SetDIBitsToDevice
! FUNCTION: SetEnhMetaFileBits
! FUNCTION: SetFontEnumeration
! FUNCTION: SetGraphicsMode
! FUNCTION: SetICMMode
! FUNCTION: SetICMProfileA
! FUNCTION: SetICMProfileW
! FUNCTION: SetLayout
! FUNCTION: SetLayoutWidth
! FUNCTION: SetMagicColors
! FUNCTION: SetMapMode
! FUNCTION: SetMapperFlags
! FUNCTION: SetMetaFileBitsEx
! FUNCTION: SetMetaRgn
! FUNCTION: SetMiterLimit
! FUNCTION: SetPaletteEntries
! FUNCTION: SetPixel
FUNCTION: BOOL SetPixelFormat ( HDC hDC, int iPixelFormat, PFD* ppfd ) ;
! FUNCTION: SetPixelV
! FUNCTION: SetPolyFillMode
! FUNCTION: SetRectRgn
! FUNCTION: SetRelAbs
! FUNCTION: SetROP2
! FUNCTION: SetStretchBltMode
! FUNCTION: SetSystemPaletteUse
! FUNCTION: SetTextAlign
! FUNCTION: SetTextCharacterExtra
FUNCTION: COLORREF SetTextColor ( HDC hdc, COLORREF crColor ) ;
! FUNCTION: SetTextColor ( HDC hDC, 
! FUNCTION: SetTextJustification
! FUNCTION: SetViewportExtEx
! FUNCTION: SetViewportOrgEx
! FUNCTION: SetVirtualResolution
! FUNCTION: SetWindowExtEx
! FUNCTION: SetWindowOrgEx
! FUNCTION: SetWinMetaFileBits
! FUNCTION: SetWorldTransform
! FUNCTION: StartDocA
! FUNCTION: StartDocW
! FUNCTION: StartFormPage
! FUNCTION: StartPage
! FUNCTION: StretchBlt
! FUNCTION: StretchDIBits
! FUNCTION: STROBJ_bEnum
! FUNCTION: STROBJ_bEnumPositionsOnly
! FUNCTION: STROBJ_bGetAdvanceWidths
! FUNCTION: STROBJ_dwGetCodePage
! FUNCTION: STROBJ_vEnumStart
! FUNCTION: StrokeAndFillPath
! FUNCTION: StrokePath
FUNCTION: BOOL SwapBuffers ( HDC hDC ) ;
! FUNCTION: TextOutA
! FUNCTION: TextOutW
! FUNCTION: TranslateCharsetInfo
! FUNCTION: UnloadNetworkFonts
! FUNCTION: UnrealizeObject
! FUNCTION: UpdateColors
! FUNCTION: UpdateICMRegKeyA
! FUNCTION: UpdateICMRegKeyW
! FUNCTION: WidenPath
! FUNCTION: XFORMOBJ_bApplyXform
! FUNCTION: XFORMOBJ_iGetXform
! FUNCTION: XLATEOBJ_cGetPalette
! FUNCTION: XLATEOBJ_hGetColorTransform
! FUNCTION: XLATEOBJ_iXlate
! FUNCTION: XLATEOBJ_piVector
